﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_big_head
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Bitmap BmHead, BmBody, BmCombined;
        private PointF Chin, Origin;

        private void Form1_Load(object sender, EventArgs e)
        {
            // The body is scaled by 0.5 so the head looks big.
            const float BodyScale = 0.5f;

            // Make the body image.
            Bitmap bm_body = (Bitmap)picBody.Image;
            int body_wid = (int)(bm_body.Width * BodyScale);
            int body_hgt = (int)(bm_body.Height * BodyScale);
            BmBody = new Bitmap(body_wid, body_hgt);
            using (Graphics gr = Graphics.FromImage(BmBody))
            {
                Point[] dest_points =
                {
                    new Point(0, 0),
                    new Point(body_wid, 0),
                    new Point(0, body_hgt),
                };
                gr.DrawImage(bm_body, dest_points);
            }

            // Make the head image, using the upper left
            // corner's color as the transparent color.
            BmHead = (Bitmap)picHead.Image;
            Color transparent = BmHead.GetPixel(0, 0);
            BmHead.MakeTransparent(transparent);

            // The tip of chin is at (273, 383) in scaled coordinates.
            Chin = new PointF(273 * BodyScale, 383 * BodyScale);

            // Origin is where we need to draw the upper left
            // corner of the head to place it on the tip of the chin.
            Origin = new PointF(
                Chin.X - BmHead.Width / 2,
                Chin.Y - BmHead.Height + 15);

            // Make the combined image.
            BmCombined = (Bitmap)BmBody.Clone();
            using (Graphics gr = Graphics.FromImage(BmCombined))
            {
                gr.DrawImage(BmHead, Origin);
            }
            picBigHead.Image = BmCombined;

            // Size the form to fit.
            ClientSize = new Size(
                picBigHead.Right + picBigHead.Left,
                picBigHead.Bottom + picBigHead.Top);
        }
    }
}
